#ifndef SYSTEM_MUTEX_H
#define SYSTEM_MUTEX_H

class IMutex {
public:
	IMutex(bool init = true) {}
	virtual ~IMutex() {}
	
	virtual bool init() = 0;
	virtual void shutdown() = 0;
	
	virtual void lock() = 0;
	virtual void unlock() = 0;
};

class MutexFactory {
public:
	static IMutex *create(bool init = true);	//defined by the module
};

class Mutex : public IMutex {
	IMutex *imp;
public:
	Mutex(bool init = true);
	virtual ~Mutex();
	
	virtual bool init();
	virtual void shutdown();
	
	virtual void lock();
	virtual void unlock();
};

class MutexLock {
private:
	Mutex *cs;
public:
	MutexLock(Mutex *_cs);
	~MutexLock();
};

#endif	//SYSTEM_MUTEX_H
